# coding: utf-8

"""
    Payment Gateway API Specification.

    The documentation here is designed to provide all of the technical guidance required to consume and integrate with our APIs for payment processing. To learn more about our APIs please visit https://docs.firstdata.com/org/gateway.  # noqa: E501

    The version of the OpenAPI document: 21.3.0.20210608.001
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class ApmPaymentMethod(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'type': 'PaymentMethodType',
        'steps': 'list[PaymentStepResponse]'
    }

    attribute_map = {
        'type': 'type',
        'steps': 'steps'
    }

    def __init__(self, type=None, steps=None):  # noqa: E501
        """ApmPaymentMethod - a model defined in OpenAPI"""  # noqa: E501

        self._type = None
        self._steps = None
        self.discriminator = None

        self.type = type
        if steps is not None:
            self.steps = steps

    @property
    def type(self):
        """Gets the type of this ApmPaymentMethod.  # noqa: E501


        :return: The type of this ApmPaymentMethod.  # noqa: E501
        :rtype: PaymentMethodType
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ApmPaymentMethod.


        :param type: The type of this ApmPaymentMethod.  # noqa: E501
        :type: PaymentMethodType
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def steps(self):
        """Gets the steps of this ApmPaymentMethod.  # noqa: E501

        All steps (already) performed on the payment  # noqa: E501

        :return: The steps of this ApmPaymentMethod.  # noqa: E501
        :rtype: list[PaymentStepResponse]
        """
        return self._steps

    @steps.setter
    def steps(self, steps):
        """Sets the steps of this ApmPaymentMethod.

        All steps (already) performed on the payment  # noqa: E501

        :param steps: The steps of this ApmPaymentMethod.  # noqa: E501
        :type: list[PaymentStepResponse]
        """

        self._steps = steps

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApmPaymentMethod):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
