# coding: utf-8

"""
    Payment Gateway API Specification.

    The documentation here is designed to provide all of the technical guidance required to consume and integrate with our APIs for payment processing. To learn more about our APIs please visit https://docs.firstdata.com/org/gateway.  # noqa: E501

    The version of the OpenAPI document: 21.3.0.20210608.001
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class RevolvingOptions(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'revolving_payment': 'bool'
    }

    attribute_map = {
        'revolving_payment': 'revolvingPayment'
    }

    def __init__(self, revolving_payment=None):  # noqa: E501
        """RevolvingOptions - a model defined in OpenAPI"""  # noqa: E501

        self._revolving_payment = None
        self.discriminator = None

        if revolving_payment is not None:
            self.revolving_payment = revolving_payment

    @property
    def revolving_payment(self):
        """Gets the revolving_payment of this RevolvingOptions.  # noqa: E501

        Indicates whether the payment has been chosen as revolving type.  # noqa: E501

        :return: The revolving_payment of this RevolvingOptions.  # noqa: E501
        :rtype: bool
        """
        return self._revolving_payment

    @revolving_payment.setter
    def revolving_payment(self, revolving_payment):
        """Sets the revolving_payment of this RevolvingOptions.

        Indicates whether the payment has been chosen as revolving type.  # noqa: E501

        :param revolving_payment: The revolving_payment of this RevolvingOptions.  # noqa: E501
        :type: bool
        """

        self._revolving_payment = revolving_payment

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RevolvingOptions):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
